/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.impl.BaseModelImpl;

import it.tref.liferay.mapit.map.service.ClpSerializer;
import it.tref.liferay.mapit.map.service.PluginPortletPreferencesLocalServiceUtil;

import java.io.Serializable;

import java.lang.reflect.Method;

import java.util.HashMap;
import java.util.Map;

/**
 * @author $author$
 */
public class PluginPortletPreferencesClp extends BaseModelImpl<PluginPortletPreferences>
	implements PluginPortletPreferences {
	public PluginPortletPreferencesClp() {
	}

	@Override
	public Class<?> getModelClass() {
		return PluginPortletPreferences.class;
	}

	@Override
	public String getModelClassName() {
		return PluginPortletPreferences.class.getName();
	}

	@Override
	public long getPrimaryKey() {
		return _pluginPortletPreferencesId;
	}

	@Override
	public void setPrimaryKey(long primaryKey) {
		setPluginPortletPreferencesId(primaryKey);
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _pluginPortletPreferencesId;
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("pluginPortletPreferencesId",
			getPluginPortletPreferencesId());
		attributes.put("ownerId", getOwnerId());
		attributes.put("ownerType", getOwnerType());
		attributes.put("plid", getPlid());
		attributes.put("portletId", getPortletId());
		attributes.put("plugin", getPlugin());
		attributes.put("preferences", getPreferences());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long pluginPortletPreferencesId = (Long)attributes.get(
				"pluginPortletPreferencesId");

		if (pluginPortletPreferencesId != null) {
			setPluginPortletPreferencesId(pluginPortletPreferencesId);
		}

		Long ownerId = (Long)attributes.get("ownerId");

		if (ownerId != null) {
			setOwnerId(ownerId);
		}

		Integer ownerType = (Integer)attributes.get("ownerType");

		if (ownerType != null) {
			setOwnerType(ownerType);
		}

		Long plid = (Long)attributes.get("plid");

		if (plid != null) {
			setPlid(plid);
		}

		String portletId = (String)attributes.get("portletId");

		if (portletId != null) {
			setPortletId(portletId);
		}

		String plugin = (String)attributes.get("plugin");

		if (plugin != null) {
			setPlugin(plugin);
		}

		String preferences = (String)attributes.get("preferences");

		if (preferences != null) {
			setPreferences(preferences);
		}
	}

	@Override
	public long getPluginPortletPreferencesId() {
		return _pluginPortletPreferencesId;
	}

	@Override
	public void setPluginPortletPreferencesId(long pluginPortletPreferencesId) {
		_pluginPortletPreferencesId = pluginPortletPreferencesId;

		if (_pluginPortletPreferencesRemoteModel != null) {
			try {
				Class<?> clazz = _pluginPortletPreferencesRemoteModel.getClass();

				Method method = clazz.getMethod("setPluginPortletPreferencesId",
						long.class);

				method.invoke(_pluginPortletPreferencesRemoteModel,
					pluginPortletPreferencesId);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public long getOwnerId() {
		return _ownerId;
	}

	@Override
	public void setOwnerId(long ownerId) {
		_ownerId = ownerId;

		if (_pluginPortletPreferencesRemoteModel != null) {
			try {
				Class<?> clazz = _pluginPortletPreferencesRemoteModel.getClass();

				Method method = clazz.getMethod("setOwnerId", long.class);

				method.invoke(_pluginPortletPreferencesRemoteModel, ownerId);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public int getOwnerType() {
		return _ownerType;
	}

	@Override
	public void setOwnerType(int ownerType) {
		_ownerType = ownerType;

		if (_pluginPortletPreferencesRemoteModel != null) {
			try {
				Class<?> clazz = _pluginPortletPreferencesRemoteModel.getClass();

				Method method = clazz.getMethod("setOwnerType", int.class);

				method.invoke(_pluginPortletPreferencesRemoteModel, ownerType);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public long getPlid() {
		return _plid;
	}

	@Override
	public void setPlid(long plid) {
		_plid = plid;

		if (_pluginPortletPreferencesRemoteModel != null) {
			try {
				Class<?> clazz = _pluginPortletPreferencesRemoteModel.getClass();

				Method method = clazz.getMethod("setPlid", long.class);

				method.invoke(_pluginPortletPreferencesRemoteModel, plid);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public String getPortletId() {
		return _portletId;
	}

	@Override
	public void setPortletId(String portletId) {
		_portletId = portletId;

		if (_pluginPortletPreferencesRemoteModel != null) {
			try {
				Class<?> clazz = _pluginPortletPreferencesRemoteModel.getClass();

				Method method = clazz.getMethod("setPortletId", String.class);

				method.invoke(_pluginPortletPreferencesRemoteModel, portletId);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public String getPlugin() {
		return _plugin;
	}

	@Override
	public void setPlugin(String plugin) {
		_plugin = plugin;

		if (_pluginPortletPreferencesRemoteModel != null) {
			try {
				Class<?> clazz = _pluginPortletPreferencesRemoteModel.getClass();

				Method method = clazz.getMethod("setPlugin", String.class);

				method.invoke(_pluginPortletPreferencesRemoteModel, plugin);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public String getPreferences() {
		return _preferences;
	}

	@Override
	public void setPreferences(String preferences) {
		_preferences = preferences;

		if (_pluginPortletPreferencesRemoteModel != null) {
			try {
				Class<?> clazz = _pluginPortletPreferencesRemoteModel.getClass();

				Method method = clazz.getMethod("setPreferences", String.class);

				method.invoke(_pluginPortletPreferencesRemoteModel, preferences);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	public BaseModel<?> getPluginPortletPreferencesRemoteModel() {
		return _pluginPortletPreferencesRemoteModel;
	}

	public void setPluginPortletPreferencesRemoteModel(
		BaseModel<?> pluginPortletPreferencesRemoteModel) {
		_pluginPortletPreferencesRemoteModel = pluginPortletPreferencesRemoteModel;
	}

	public Object invokeOnRemoteModel(String methodName,
		Class<?>[] parameterTypes, Object[] parameterValues)
		throws Exception {
		Object[] remoteParameterValues = new Object[parameterValues.length];

		for (int i = 0; i < parameterValues.length; i++) {
			if (parameterValues[i] != null) {
				remoteParameterValues[i] = ClpSerializer.translateInput(parameterValues[i]);
			}
		}

		Class<?> remoteModelClass = _pluginPortletPreferencesRemoteModel.getClass();

		ClassLoader remoteModelClassLoader = remoteModelClass.getClassLoader();

		Class<?>[] remoteParameterTypes = new Class[parameterTypes.length];

		for (int i = 0; i < parameterTypes.length; i++) {
			if (parameterTypes[i].isPrimitive()) {
				remoteParameterTypes[i] = parameterTypes[i];
			}
			else {
				String parameterTypeName = parameterTypes[i].getName();

				remoteParameterTypes[i] = remoteModelClassLoader.loadClass(parameterTypeName);
			}
		}

		Method method = remoteModelClass.getMethod(methodName,
				remoteParameterTypes);

		Object returnValue = method.invoke(_pluginPortletPreferencesRemoteModel,
				remoteParameterValues);

		if (returnValue != null) {
			returnValue = ClpSerializer.translateOutput(returnValue);
		}

		return returnValue;
	}

	@Override
	public void persist() throws SystemException {
		if (this.isNew()) {
			PluginPortletPreferencesLocalServiceUtil.addPluginPortletPreferences(this);
		}
		else {
			PluginPortletPreferencesLocalServiceUtil.updatePluginPortletPreferences(this);
		}
	}

	@Override
	public PluginPortletPreferences toEscapedModel() {
		return (PluginPortletPreferences)ProxyUtil.newProxyInstance(PluginPortletPreferences.class.getClassLoader(),
			new Class[] { PluginPortletPreferences.class },
			new AutoEscapeBeanHandler(this));
	}

	@Override
	public Object clone() {
		PluginPortletPreferencesClp clone = new PluginPortletPreferencesClp();

		clone.setPluginPortletPreferencesId(getPluginPortletPreferencesId());
		clone.setOwnerId(getOwnerId());
		clone.setOwnerType(getOwnerType());
		clone.setPlid(getPlid());
		clone.setPortletId(getPortletId());
		clone.setPlugin(getPlugin());
		clone.setPreferences(getPreferences());

		return clone;
	}

	@Override
	public int compareTo(PluginPortletPreferences pluginPortletPreferences) {
		long primaryKey = pluginPortletPreferences.getPrimaryKey();

		if (getPrimaryKey() < primaryKey) {
			return -1;
		}
		else if (getPrimaryKey() > primaryKey) {
			return 1;
		}
		else {
			return 0;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof PluginPortletPreferencesClp)) {
			return false;
		}

		PluginPortletPreferencesClp pluginPortletPreferences = (PluginPortletPreferencesClp)obj;

		long primaryKey = pluginPortletPreferences.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(15);

		sb.append("{pluginPortletPreferencesId=");
		sb.append(getPluginPortletPreferencesId());
		sb.append(", ownerId=");
		sb.append(getOwnerId());
		sb.append(", ownerType=");
		sb.append(getOwnerType());
		sb.append(", plid=");
		sb.append(getPlid());
		sb.append(", portletId=");
		sb.append(getPortletId());
		sb.append(", plugin=");
		sb.append(getPlugin());
		sb.append(", preferences=");
		sb.append(getPreferences());
		sb.append("}");

		return sb.toString();
	}

	@Override
	public String toXmlString() {
		StringBundler sb = new StringBundler(25);

		sb.append("<model><model-name>");
		sb.append("it.tref.liferay.mapit.map.model.PluginPortletPreferences");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>pluginPortletPreferencesId</column-name><column-value><![CDATA[");
		sb.append(getPluginPortletPreferencesId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>ownerId</column-name><column-value><![CDATA[");
		sb.append(getOwnerId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>ownerType</column-name><column-value><![CDATA[");
		sb.append(getOwnerType());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>plid</column-name><column-value><![CDATA[");
		sb.append(getPlid());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>portletId</column-name><column-value><![CDATA[");
		sb.append(getPortletId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>plugin</column-name><column-value><![CDATA[");
		sb.append(getPlugin());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>preferences</column-name><column-value><![CDATA[");
		sb.append(getPreferences());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _pluginPortletPreferencesId;
	private long _ownerId;
	private int _ownerType;
	private long _plid;
	private String _portletId;
	private String _plugin;
	private String _preferences;
	private BaseModel<?> _pluginPortletPreferencesRemoteModel;
}