package it.tref.liferay.mapit.map.messaging;

import it.tref.liferay.mapit.map.hook.deploy.DeployUtil;

import java.util.List;

import com.liferay.portal.kernel.deploy.DeployManagerUtil;
import com.liferay.portal.kernel.messaging.BaseMessageListener;
import com.liferay.portal.kernel.messaging.Message;
import com.liferay.portal.kernel.plugin.PluginPackage;
import com.liferay.portal.kernel.util.ClassLoaderPool;

public class HotDeployMessageListener extends BaseMessageListener {

  @Override
  protected void doReceive(Message message) throws Exception {

    String command = message.getString("command");
    String servletContextName = message.getString("servletContextName");

    if (command.equals("deploy")) {

      ClassLoader classLoader = ClassLoaderPool.getClassLoader(servletContextName);

      PluginPackage pluginPackage = null;

      List<PluginPackage> pluginsPackage = DeployManagerUtil.getInstalledPluginPackages();
      for (int i = 0; i < pluginsPackage.size() && pluginPackage == null; i++) {
        if (pluginsPackage.get(i).getContext().equals(servletContextName)) {
          pluginPackage = pluginsPackage.get(i);
        }
      }

      DeployUtil.checkMapItPluginOnDeploy(pluginPackage, classLoader);
    } else if (command.equals("undeploy")) {

      ClassLoader classLoader = ClassLoaderPool.getClassLoader(servletContextName);
      DeployUtil.checkMapItPluginOnUndeploy(servletContextName, classLoader);
    }
  }

}
